using System;
using System.ComponentModel.DataAnnotations.Schema;

namespace ELTE.TravelAgency.Model
{
    public class Rent
    {
	    public int Id { get; set; }
		[ForeignKey("Guest")]
		public int UserId { get; set; }
        public int ApartmentId { get; set; }
        public DateTime StartDate { get; set; }
        public DateTime EndDate { get; set; }
    
        public Apartment Apartment { get; set; } = null!;
		public Guest Guest { get; set; } = null!;

		/// <summary>
		/// tkzik-e egy msik foglalssal.
		/// </summary>
		/// <param name="startDate">A foglals kezdete.</param>
		/// <param name="endDate">A foglals vge.</param>
		/// <returns>Igaz, ha tkzik, egybknt hamis.</returns>
		public Boolean IsConflicting(DateTime startDate, DateTime endDate)
	    {
			return StartDate >= startDate && StartDate < endDate ||
				   EndDate > startDate && EndDate < endDate ||
				   startDate >= StartDate && startDate < EndDate ||
				   endDate > StartDate && endDate < EndDate;
		}
	}
}
